// TstRtti.java
package jwiley.chp3;

import java.awt.Color;

/**
 * Class to demonstrate a parent class.
 * Not a complete implementation.
 */
class graphicImage
{
    /** name of image. */
    protected String name;
    /** width and height of image. */
    protected int pixelsHigh, pixelsWide;
    /** 2d array of colors. */
    protected Color bitmap[][];

    /** method to decode an image. */
    void decode()
    {
        System.out.println("Decode a generic image.");
        for (int i=0; i < pixelsHigh; i++)
                for (int j=0; j < pixelsWide; j++)
                        ; // get each pixel
    }

    /** accessor. */
    String getName()
    { return name; }
}

/**
 * Specific subclass of graphic image.
 */
class GIFimage extends graphicImage
{
    // GIF data members

    /** constructor. */
    GIFimage()
    {
        // GIF constructor
        name = "GIFimage";
    }

    /** method to decode  a .GIF file. */
    void decode()
    {
        // decode the file in a GIF-specific way
        System.out.println("Decode a GIF file.");
    }
}

/**
 * Specific subclass of graphic image.
 */
class PICTimage extends graphicImage
{
    // PICT data members
    /** constructor. */
    PICTimage()
    {
        // PICT constructor
        name = "PICTimage";
    }

    /** method to decode a PICT image. */
    void decode()
    {
        // decode the file in a PICT-specific way
        System.out.println("Decode a PICT file.");
    }
}

/**
 * Wrapper class to demonstrate Java Run Time Type
 * Identification (RTTI).
 */
class tstRtti
{
    /** method to process some graphic file. */
    static void processFile(graphicImage type)
    {
        type.decode();
    }

    /** main() method to invoke from the JVM. */
    public static void main(String args[])
    {
        GIFimage gImage = new GIFimage();
        PICTimage pImage = new PICTimage();

        processFile(gImage);
        processFile(pImage);
    }
}
