/** ListNode.java */
package List;

/** Generic linked list node. */
public abstract class ListNode
{
    /** data in node. */
	Object data;

    /** constructor. */
	public ListNode(Object inData)
	{
		data = inData;
	}

    /** method to link a node to the list. */
	abstract void Link(ListNode prev);
	/** access next node in list. */
	abstract ListNode next();
	/** access previous node in list. */
	abstract ListNode prev() throws IllegalListOpException;
}
