/** RandomRobot.java */
package jwiley.chp4.Robots;

import jwiley.chp4.Robot;

import java.util.Random;

public class RandomRobot implements Robot
{
    Random dice = new Random();
    int iValue;
    int iArmor;
    int iSpeed;
    int iFirePower;

    public void setInitialCapital(int units)
    {
        iValue = units;

        // randomly distribute expenditures
        int iRoll = Math.abs(dice.nextInt() % units);
        iArmor = iRoll;
        int iLeft = units - iArmor;
        if (iLeft > 0)
        {
            iRoll = Math.abs(dice.nextInt() % iLeft);
            iSpeed = iRoll;
            iLeft -= iSpeed;
            iFirePower = iLeft;
        }
        else
        {
            iSpeed = iFirePower = 0;
        }
    }

    public int getArmor()
    { return iArmor; }
    public int getFirePower()
    { return iFirePower; }
    public int getSpeed()
    { return iSpeed; }
    public void setArmor(int curArmor)
    { iArmor = curArmor; }
    public void setFirePower(int curFirePower)
    { iFirePower = curFirePower; }
    public void setSpeed(int curSpeed)
    { iSpeed = curSpeed; }
    public int getNextAction()
    {
        return Math.abs(dice.nextInt() % (Robot.TOTAL_ACTIONS + 1));
    }

    public void assessOpponent(int currentUnits) { }

    public String toString()
    {
        return "RandomRobot: Armor(" + iArmor + ") " +
               "Speed(" + iSpeed + ") " +
               "FirePower(" + iFirePower + ")";
    }

    public String getName()
    { return "RandomRobot"; }
}
