// bookShelf.java
import book;

/**
 * Class which represents a bookshelf and stores books in a singly
 * linked list.
 * @version 1.1
 * @author Michael C. Daconta
 */
public class bookShelf
{
    /** Reference to first and last book objects. */
    protected book first,last;

    /** Count of books in bookShelf. */
    protected long count;

    /** Method to add a book object to the list. */
    public void add(book aBook)
    {
        if (first != null)
        {
            last.next = aBook;
            last = last.next;
        }
        else
        {
            first = aBook;
            last = first;
        }
        count++;
    }

    /** Method to get the size of the linked list. */
    public long size() { return count; }

    /** Method to print all books in the bookShelf. */
    public void print()
    {
        book curBook = first;
        int cnt=1;

        while (curBook != null)
        {
            System.out.println("Book: " + cnt++);
            curBook.showBook();
            curBook = curBook.next;
        }
    }
}
