@ECHO Off
REM
REM signfile.bat 
REM             
REM This dos batch procedure signs a jar file with the signature
REM defined in teh sign_directive file.  The signer must have already been
REM in place in the database.


REM Compile the test file
Echo Compiling the java files
javac testJar.java

REM Create the associated jar file
Echo Jaring the java files
jar cf signedtestjar.jar testjar.class testjar.html

REM Sign the jar file 
Echo Signing the generated Jar file
javakey -gs sign_directive_ASaganich signedtestjar.jar

REM delete the .jar original and rename the signed version to the original name
del signedtestjar.jar
rename  signedtestjar.jar.sig signedtestjar.jar

REM Done!
Echo Contents of the archive are: 
jar tvf signedtestjar.jar
Echo Contents of the identity database are: 
javakey -ld


             
             
