// TestDataTypes.java
package jwiley.chp2;

/**
 * class to demonstrate Java data types.
 * @author Michael C. Daconta
 */
class TestDataTypes
{
   /** main method. */
   public static void main(String args[])
   {
        // primitives (space allocated)
        int localInt = 10;
        double localDoub = 20.459;

        System.out.println("Primitive types");
        System.out.println("localInt has the value: " + localInt);
        System.out.println("localDoub has the value: " + localDoub);

        // references types
        int [] intArrayReference = null;
        similar2Struct classReference = null;
        String stringReference = null;
        Double doubleObjectReference = null;

        System.out.println("Reference type");
        System.out.println("intArrayReference has the value: " + intArrayReference);
        System.out.println("classReference has the value: " + classReference);
        System.out.println("stringReference has the value: " + stringReference);
        System.out.println("doubleObjectReference has the value: "
                           + doubleObjectReference);

        // only other valid value for a reference type
        intArrayReference = new int[5];
        classReference = new similar2Struct();
        stringReference = new String("mike");
        doubleObjectReference = new Double(20.459);
        System.out.println("Allocated references.");
        System.out.println("intArrayReference has the value: " + intArrayReference);
        System.out.println("classReference has the value: " + classReference);
        System.out.println("stringReference has the value: " + stringReference);
        System.out.println("doubleObjectReference has the value: "
                           + doubleObjectReference);

   }
}

/**
 * A sample class.
 */
class similar2Struct
{
    int dmInt;
    Float dmFloat;
    Long dmLong;
}
