// VarArgs.java
package jwiley.chp2;

import java.util.Vector;
/**
 * Class to demonstrate how to simulate variable arguments
 * in java.
 */
class VarArgs
{
    /** method to sum a series of numbers. */
    static long sum(Vector ints)
    {
        long total = 0;
        for (int i=0; i < ints.size(); i++)
                total += ((Integer)ints.elementAt(i)).intValue();
        return total;
    }

    /** Main() method to invoke from JVM. */
    public static void main(String args[])
    {
        Vector intVec = new Vector(3);
        intVec.addElement(new Integer(5));
        intVec.addElement(new Integer(10));
        intVec.addElement(new Integer(20));
        intVec.addElement(new Integer(30));
        long theTot = sum(intVec);
        System.out.println("The total is " + theTot);
    }
}
