import java.util.Enumeration;

class Bookshelf {
        protected book first,last;
        protected long count;

        Bookshelf()
        {
                first = last = null;
                count = 0;
        }

        void add(book aBook)
        {
				book previous;
				if (first != null)
                {
						previous = last;
                        last.next = new book(aBook);
                        last = last.next;
						last.previous = previous;
                }
                else
                {
                        first = new book(aBook);
                        last = first;
						first.previous = null;
                }
 				count++;
        }

        long size() { return count; }

        void print()
        {
                book curBook = first;
                int cnt=1;

                while (curBook != null)
                {
                        System.out.println("Book: " + cnt++);
                        curBook.showBook();
                        curBook = curBook.next;
                }
        }


        class Enumerator implements java.util.Enumeration
        {
            book current = first;
            book toBeReturned;
            public boolean hasMoreElements()
            {
                return current != null;
            }

            public Object nextElement() 
            {
                if ( current == null)
                    return null;
                toBeReturned = current;
                current = current.next;
                return toBeReturned;
            }           
        }
        public  Enumeration forward()
        {
			return new Enumerator();
		}

		public Enumeration backward()
		{
			return new Enumeration()
			{
				book current = last;
				book toBeReturned;
				public boolean hasMoreElements()
				{
					return current != null;
				}
				public Object nextElement() 
				{
					if ( current == null)
						return null;
					toBeReturned = current;
					current = current.previous;
					return toBeReturned;
				}
			}; // end Return new...
		} // End backwards

}

class bookMain3 {
        public static void main(String args[])
        {
                Bookshelf mybooks = new Bookshelf();
                java.util.Enumeration myEnumeration;
                boolean done = false;

                System.out.println("Enter your books.");
                System.out.println("Type 'done' when finished.");
                while (!done)
                {
                        book curBook = new book();
                        curBook.getBook();
                        if (!(curBook.getTitle()).equals("done"))
                        {
                                mybooks.add(curBook);
                        }
                        else
                                done = true;

                }

                // print the books in the shelf
                System.out.println("Number of books in bookshelf(by forward enumeration): " +
                                                mybooks.size());
                int cnt = 0;
                myEnumeration = mybooks.forward();
                while (myEnumeration.hasMoreElements())
                {
                    book aBook = (book) myEnumeration.nextElement();
                    System.out.println("Book: " + cnt++);
                    aBook.showBook();
                }


                System.out.println("Number of books in bookshelf(by backward enumeration): " +
                                                mybooks.size());
				cnt = 0;
                myEnumeration = mybooks.backward();
                while (myEnumeration.hasMoreElements())
                {
                    book aBook = (book) myEnumeration.nextElement();
                    System.out.println("Book: " + cnt++);
                    aBook.showBook();
                }


        }
}
