/** SingleLink.java. */
package List;

/** Class to represent a node in a singly linked list. */
public class SingleLink extends ListNode
{
    /** reference to NEXT node in list. */
	SingleLink next;

    /** constructor. */
	public SingleLink(Object theData)
	{
		super(theData);
	}

    /** Method to connect this node to previous node. */
	public void Link(ListNode prev)
	{
		((SingleLink)prev).next = this;
	}

    /** Method to access the next node in the list. */
	public ListNode next()
	{
		return this.next;
	}

    /** Method to access the previous node in the list. */
	public ListNode prev() throws IllegalListOpException
	{
		throw new IllegalListOpException("No prev() in singly" +
					  					   " linked lists.");
	}
}
