/** Robot.java. */
package jwiley.chp4;

public interface Robot
{
    public final int ACTION_OFFENSIVE_ATTACK = 0;
    public final int ACTION_DEFENSIVE_BLOCK = 1;
    public final int ACTION_FLEE = 2;

    public final int TOTAL_ACTIONS = 3;

    public void setInitialCapital(int units);
    public int getArmor();
    public int getFirePower();
    public int getSpeed();
    public void setArmor(int curArmor);
    public void setFirePower(int curFirePower);
    public void setSpeed(int curSpeed);
    public int getNextAction();
    public void assessOpponent(int currentUnits);
    public String toString();
    public String getName();
}