// TestObject.java
package jwiley.chp6;

/** simple test object. */
class Aobj implements Cloneable
{
    /** int data member. */
    int inum;
    /** one arg constructor. */
    Aobj(int inNum) { inum = inNum; }

    /** accessor. */
    int getNum() { return inum; }

    /** clone method. */
    public Object clone()
    {
        try
        {
            Object result = super.clone();
            return result;
        } catch (Exception e) { return null; }
    }
}

/** simple test object. */
class Bobj
{
    /** float data member. */
    float fnum;
    /** constructor. */
    Bobj(float inNum) { fnum = inNum; }
    /** accessor. */
    float getNum() { return fnum; }
}

/** Simple class to test the Object class. */
public class TestObject
{
    /** main() method to invoke from the JVM. */
    public static void main(String args[])
    {
        Aobj a1 = new Aobj(10);
        Aobj a2 = new Aobj(20);
        Bobj b1 = new Bobj((float)5.0);

        if (a1.equals(a2))
            System.out.println("a1 equals a2");

        if (a1.equals(b1))
            System.out.println("a1 equals b1");
        else
            System.out.println("a1 does NOT equal b1");

        Aobj a3 = (Aobj) a1.clone();
        System.out.println("a1 is            : " + a1.toString());
        System.out.println("a3 is an a1 clone: " + a3.toString());
    }
}
